-- WAITFOR
DROP TABLE IF EXISTS Test..Numbers;
CREATE TABLE Test..Numbers(Number INT);
declare @x int
select @x=2
insert into Test..Numbers values( @x );
print 'Wstawiono...'
waitfor delay '00:00:05'
insert into Test..Numbers values( @x+2 );
print 'Wstawiono...'
GO

-- IF..ELSE
if EXISTS( select * from Northwind..orders) print('S zamwienia')
else print('Nie ma adnych zamwie')
GO

-- WHILE
declare @y int
select @y=0
while ( @y<10 )
begin
  print @y
  if ( @y=5 ) break
  set @y=@y+1
end

-- CASE
select Tytul as Tytu, Cena, [Cena jest]=CASE
	when Cena<40.00 then 'Niska'
	when Cena between 40.00 and 80.00 then 'Przystpna'
	when Cena>80 then 'Wysoka'
	else 'Nieznana'
	end
from Test..Ksiazka

select p.ProductName, Kategoria=CASE c.CategoryName
	when 'Beverages' then 'Napoje'
	when 'Condiments' then 'Przyprawy'
	when 'Confections' then 'Sodycze'
	when 'Dairy Products' then 'Nabia'
	else 'Inne'
	end
from Northwind..Products p JOIN Northwind..Categories c ON p.CategoryID=c.CategoryID
-- Jak powysze naley waciwie zrobi?

-- NULLIF
-- przydatne, kiedy chcemy pomin jak warto w funkcjach agregujcych
select
count(*) as [Liczba produktw],
avg( nullif( UnitsInStock, 0 ) ) as [rednia liczba sztuk],
min( nullif( UnitsInStock, 0 ) ) as [Minimalna liczba sztuk]
from Northwind..Products

-- ISNULL
-- pozwala na nadawanie wartoci domylnych tam, gdzie jest NULL
SELECT FirstName, LastName, ISNULL(PhotoPath, 'http://jakasdomyslnafocia.pl/') FROM Northwind..Employees
-- mona te umieszcza podzapytania, np.: isnull( price, ( select MIN(price) from ceny ) )
